import dynamixel_jni.*;
import procontroll.*;
import net.java.games.input.*;
import processing.video.*;

ControllIO controllIO;
ControllDevice joypad;
ControllStick stick1;
ControllStick stick2;
Capture video;

static int P_GOAL_POSITION_L=30;
static int P_GOAL_POSITION_H=31;
static int P_GOAL_SPEED_L=32;
static int P_GOAL_SPEED_H=33;
static int P_PRESENT_POSITION_L=36;
static int P_PRESENT_POSITION_H=37;
static int P_MOVING=46;
static int P_MODEL_NUMBER_L = 0;	// Model number low byte
static int P_MODEL_NUMBER_H = 1;	// Model number high byte
static int P_VERSION = 2;	// Firmware version

float transX;
float transY;
int headYaw,headPitch,headBase;


void setup(){
  size(1024, 768); 
  video = new Capture(this, 320, 240, 24);

  int res,wValue,bValue,id;

  
  transY = height/2;

  controllIO = ControllIO.getInstance(this);

  joypad = controllIO.getDevice("USB Joystick ");
  joypad.plug(this, "handleMovement", ControllIO.WHILE_PRESS, 0);

  stick1 = joypad.getStick(0);
  stick1.setMultiplier(100);
  stick2 = joypad.getStick(1);
  stick2.setMultiplier(100);  
  
  res = dynamixel_jni.dxl_initialize();
  if(res==1)
  {
    println("Succeed to open USB2Dynamixel!"); 
    dynamixel_jni.dxl_set_baud(1);
    for(id=1;id<20;id++)
    {
      dynamixel_jni.dxl_ping(id);
      if (dynamixel_jni.dxl_get_result() == dynamixel_jni.COMM_RXSUCCESS)
      {
        System.out.printf("-ID:%d (", id);
	wValue = dynamixel_jni.dxl_read_word(id, P_MODEL_NUMBER_L);
	if (dynamixel_jni.dxl_get_result() == dynamixel_jni.COMM_RXSUCCESS)
	  System.out.printf("Model number:%d, ", wValue);
	else
	  println("Error during communication");
	bValue = dynamixel_jni.dxl_read_byte(id, P_VERSION);
	if (dynamixel_jni.dxl_get_result() == dynamixel_jni.COMM_RXSUCCESS)
	  System.out.printf("Version:%d", bValue);
	else
	  println("Error during communication");
	System.out.println(")");
      }
    }
  }
  else
  {
    println("Failed to open USB2Dynamixel!");
    dynamixel_jni.dxl_terminate();
    println("Press any key to terminate...");
  }
  headBase = dynamixel_jni.dxl_read_word( 10, P_PRESENT_POSITION_L );
  if( dynamixel_jni.dxl_get_result() == dynamixel_jni.COMM_RXSUCCESS )
  {
   println("base: " + headBase);   
  }
  headPitch =dynamixel_jni.dxl_read_word( 15, P_PRESENT_POSITION_L );
    if( dynamixel_jni.dxl_get_result() == dynamixel_jni.COMM_RXSUCCESS )
  {
   println("pitch: "+ headPitch);   
  }
  headYaw =dynamixel_jni.dxl_read_word( 7, P_PRESENT_POSITION_L );
  if( dynamixel_jni.dxl_get_result() == dynamixel_jni.COMM_RXSUCCESS )
  {
   println("yaw: "+ headYaw);   
  }
  transX = headYaw;
}

void handleMovement(final float i_x,final float i_y){
  transX += i_x;
  transY += i_y;
}

void draw(){
  int R,Q,W;
  R = (int)(stick1.getX()+500);
  Q = min((int)(stick1.getY()+500),500);
  W = (int)(stick2.getY()+500);
  if (video.available()) {
    video.read();
    set(((500-R)*3)+350, ((W-500)*3)+200, video);
  }
    dynamixel_jni.dxl_write_word( 7, P_GOAL_POSITION_L ,R);//P_GOAL_POSITION_L   
   dynamixel_jni.dxl_write_word( 15, P_GOAL_POSITION_L , Q );//P_GOAL_POSITION_L
    dynamixel_jni.dxl_write_word( 10, P_GOAL_POSITION_L , W );//P_GOAL_POSITION_L
}
